> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# CRUD: Update a product rate plan

PUT https://rest.test.zuora.com/v1/object/product-rate-plan/{id}
Content-Type: application/json

Updates a product rate plan.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/legacy-v1-products/product-rate-plans/object-put-product-rate-plan

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `id` (string, required) — Object id

### Query parameters

- `rejectUnknownFields` (boolean, optional, default: false) — Specifies whether the call fails if the request body contains unknown fields. With `rejectUnknownFields` set to `true`, Zuora returns a 400 response if the request body contains unknown fields. The body of the 400 response is: ```json { "message": "Error - unrecognised fields" } ``` By default, Zuora ignores unknown fields in the request body.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `X-Zuora-WSDL-Version` (string, optional, default: 79) — Zuora WSDL version number.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a ProxyModifyProductRatePlan.

- `ActiveCurrencies` (list of string, optional) — A list of 3-letter currency codes representing active currencies for the product rate plan. Use a comma to separate each currency code. If the request body contains this field, the value of this field must contain the desired list of active currencies. The new list can never have more than four differences from the existing list. This field cannot be used to modify the status of more than four currencies in a single request. For example, in a single request, you can only activate four currencies, or deactivate four currencies, or activate two and deactivate two. Making more than four changes to currencies always requires more than one call. When specifying this field in the update request, you must provide the full list of active currencies you want, not just incremental changes. For each active currency update, provide the following currencies in the list: Current active currencies + at most four changes (additions or deletions)
- `Description` (string, optional) — A description of the product rate plan.
- `EffectiveEndDate` (date, optional) — The date when the product rate plan expires and can't be subscribed to, in `yyyy-mm-dd` format.
- `EffectiveStartDate` (date, optional) — The date when the product rate plan becomes available and can be subscribed to, in `yyyy-mm-dd` format.
- `ExternalIdSourceSystem` (string, optional) — The ID of the external source system. **Note:** To use this field, you must set the `X-Zuora-WSDL-Version` request header to `130` or later. Otherwise, an error occurs.
- `ExternalRatePlanIds` (string, optional) — An external ID of the product rate plan to be added. You can use this field to specify a product rate plan that is imported from an external system. If you want to update to multiple values, use a comma separated string. **Note:** To use this field, you must set the `X-Zuora-WSDL-Version` request header to `130` or later. Otherwise, an error occurs.
- `Grade` (double, optional) — The grade that is assigned for the product rate plan. The value of this field must be a positive integer. The greater the value, the higher the grade. A product rate plan to be added to a Grading catalog group must have one grade. You can specify a grade for a product rate plan in this request or update the product rate plan individually. **Notes**: - To use this field, you must set the `X-Zuora-WSDL-Version` request header to `116` or later. Otherwise, an error occurs. - This field is in the **Early Adopter** phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. If you want to join this early adopter program, submit a request at [Zuora Global Support](http://support.zuora.com/).
- `Name` (string, optional) — The name of the product rate plan. The name doesn't have to be unique in a Product Catalog, but the name has to be unique within a product.
- `ProductId` (string, optional) — The ID of the product that contains the product rate plan.
- `ProductRatePlanNumber` (string, optional) — The natural key of the product rate plan. For existing Product Rate Plan objects that are created before this field is introduced, this field will be null. Use this field to specify a value for only these objects. Zuora also provides a tool to help you automatically backfill this field with tenant ID for your existing product catalog. If you want to use this backfill tool, contact [Zuora Global Support](https://support.zuora.com/). **Note**: This field is only available if you set the `X-Zuora-WSDL-Version` request header to `133` or later.
- `BillingPeriod__NS` (enum, optional) — Billing period associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
  - Allowed values: `Monthly`, `Quarterly`, `Annual`, `Semi-Annual`
- `Class__NS` (string, optional) — Class associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Department__NS` (string, optional) — Department associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IncludeChildren__NS` (enum, optional) — Specifies whether the corresponding item in NetSuite is visible under child subsidiaries. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
  - Allowed values: `Yes`, `No`
- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the product rate plan's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `ItemType__NS` (enum, optional) — Type of item that is created in NetSuite for the product rate plan. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
  - Allowed values: `Inventory`, `Non Inventory`, `Service`
- `Location__NS` (string, optional) — Location associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `MultiCurrencyPrice__NS` (string, optional) — Multi-currency price associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Price__NS` (string, optional) — Price associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Subsidiary__NS` (string, optional) — Subsidiary associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the product rate plan was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).

## Response

### 200

OK

- `Id` (string, optional)
- `Success` (boolean, optional)

## Errors

### 401 Unauthorized Error

Unauthorized

- `message` (string, optional) — Error message. If the error message is "Authentication error", ensure that the `Authorization` request header contains valid authentication credentials, then retry the request. See [Authentication](https://developer.zuora.com/docs/guides/authentication/) for more information. If the error message is "Failed to get user info", retry the request.

## Examples

**Request**

```json
{
  "ActiveCurrencies": [
    "USD"
  ],
  "Description": "monthly plan",
  "ExternalIdSourceSystem": "extsys9",
  "ExternalRatePlanIds": "ext01",
  "Name": "Monthly Plan2",
  "ProductId": "8ad081dd90c4bafe0190desada8f9b154b"
}
```

**Response**

```json
{
  "Id": "2c93808457d787030157e02da0d91852",
  "Success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/object/product-rate-plan/id"

payload = {
    "ActiveCurrencies": ["USD"],
    "Description": "monthly plan",
    "ExternalIdSourceSystem": "extsys9",
    "ExternalRatePlanIds": "ext01",
    "Name": "Monthly Plan2",
    "ProductId": "8ad081dd90c4bafe0190desada8f9b154b"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/object/product-rate-plan/id';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"ActiveCurrencies":["USD"],"Description":"monthly plan","ExternalIdSourceSystem":"extsys9","ExternalRatePlanIds":"ext01","Name":"Monthly Plan2","ProductId":"8ad081dd90c4bafe0190desada8f9b154b"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/object/product-rate-plan/id"

	payload := strings.NewReader("{\n  \"ActiveCurrencies\": [\n    \"USD\"\n  ],\n  \"Description\": \"monthly plan\",\n  \"ExternalIdSourceSystem\": \"extsys9\",\n  \"ExternalRatePlanIds\": \"ext01\",\n  \"Name\": \"Monthly Plan2\",\n  \"ProductId\": \"8ad081dd90c4bafe0190desada8f9b154b\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/object/product-rate-plan/id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"ActiveCurrencies\": [\n    \"USD\"\n  ],\n  \"Description\": \"monthly plan\",\n  \"ExternalIdSourceSystem\": \"extsys9\",\n  \"ExternalRatePlanIds\": \"ext01\",\n  \"Name\": \"Monthly Plan2\",\n  \"ProductId\": \"8ad081dd90c4bafe0190desada8f9b154b\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://rest.test.zuora.com/v1/object/product-rate-plan/id")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"ActiveCurrencies\": [\n    \"USD\"\n  ],\n  \"Description\": \"monthly plan\",\n  \"ExternalIdSourceSystem\": \"extsys9\",\n  \"ExternalRatePlanIds\": \"ext01\",\n  \"Name\": \"Monthly Plan2\",\n  \"ProductId\": \"8ad081dd90c4bafe0190desada8f9b154b\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://rest.test.zuora.com/v1/object/product-rate-plan/id', [
  'body' => '{
  "ActiveCurrencies": [
    "USD"
  ],
  "Description": "monthly plan",
  "ExternalIdSourceSystem": "extsys9",
  "ExternalRatePlanIds": "ext01",
  "Name": "Monthly Plan2",
  "ProductId": "8ad081dd90c4bafe0190desada8f9b154b"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/object/product-rate-plan/id");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"ActiveCurrencies\": [\n    \"USD\"\n  ],\n  \"Description\": \"monthly plan\",\n  \"ExternalIdSourceSystem\": \"extsys9\",\n  \"ExternalRatePlanIds\": \"ext01\",\n  \"Name\": \"Monthly Plan2\",\n  \"ProductId\": \"8ad081dd90c4bafe0190desada8f9b154b\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "ActiveCurrencies": ["USD"],
  "Description": "monthly plan",
  "ExternalIdSourceSystem": "extsys9",
  "ExternalRatePlanIds": "ext01",
  "Name": "Monthly Plan2",
  "ProductId": "8ad081dd90c4bafe0190desada8f9b154b"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/object/product-rate-plan/id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```